//+------------------------------------------------------------------+
//|                                                          SGA.mq4 |
//|                                                    .. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " .."
#property link      "alextar@bk.ru"
#define VeryBigValue 1000000000.0                        //   .
#define ClassTotal 2                                     //  .
#define TypeTotal 13                                     //  .
#define PropertyTotal 39                                 //  .
#define GroupTotal 1000                                  //  .
//  :
int LastErrorCode,                                       //  .
    FirstBreakBar, LastBreakBar,                         //   .
    BarDevMax, BarDevMin, BarPriceMax, BarPriceMin;      //     
double DevMin, DevMax, PriceMin, PriceMax;               //         .
//  :
extern int BarsBeforeActivate=1,
           BarsBeforeConfirm;
extern bool TraceIsAllowed,                              //  ?
            IsStaticMode,                                //    ?
            ClearAtFinish=true,                          //    ?
            ExcludeFirstBar=true,                        //     ?
            ExcludeLastBar=true;                         //     ?
extern color RasingLinesColor=Teal,
             ReducingLinesColor=Magenta;
//   :
string Type.Prefix[ClassTotal,TypeTotal];                // .
color Type.Color[ClassTotal,TypeTotal];                  // .
bool Type.Back[ClassTotal,TypeTotal];                    // ?
int Type.Style[ClassTotal,TypeTotal],                    // .
    Type.Width[ClassTotal,TypeTotal];                    // .
//   :
double Property[ClassTotal,GroupTotal,PropertyTotal];
//   :
bool Tangent.Actual,
     Tangent.Finite,
     Level.Finite,
     Level.Break.Finite,
     Level.Recoil.Finite,
     Border.Finite,
     Border.Break.Finite,
     Border.Recoil.Finite,
     Trend.Finite,
     Limit.Finite,
     Horizon.Finite,
     Trace.Finite,
     Trace.Break.Finite,
     Trace.Recoil.Finite;
int Tangent.Bar1, Tangent.Bar2,
    Level.Bar1, Level.Bar2,
    Level.Break.Bar1, Level.Break.Bar2,
    Level.Recoil.Bar1, Level.Recoil.Bar2,
    Border.Bar1, Border.Bar2,
    Border.Break.Bar1, Border.Break.Bar2,
    Border.Recoil.Bar1, Border.Recoil.Bar2,
    Trend.Bar1, Trend.Bar2,
    Limit.Bar1, Limit.Bar2,
    Horizon.Bar1, Horizon.Bar2,
    Trace.Bar1, Trace.Bar2,
    Trace.Break.Bar1, Trace.Break.Bar2,
    Trace.Recoil.Bar1, Trace.Recoil.Bar2;
double Tangent.Price1, Tangent.Price2, Tangent.Speed,
       Level.Price,
       Level.Break.Price,
       Level.Recoil.Price,
       Border.Price1, Border.Price2,
       Border.Break.Price1, Border.Break.Price2,
       Border.Recoil.Price1, Border.Recoil.Price2,
       Trend.Price1, Trend.Price2,
       Limit.Price,
       Horizon.Price1, Horizon.Price2,
       Trace.Price1, Trace.Price2,
       Trace.Break.Price1, Trace.Break.Price2,
       Trace.Recoil.Price1, Trace.Recoil.Price2;
datetime Tangent.Time1, Tangent.Time2,                   // .
         Level.Time1, Level.Time2,                       // .
         Level.Break.Time1, Level.Break.Time2,           //  .
         Level.Recoil.Time1, Level.Recoil.Time2,         //   .
         Border.Time1, Border.Time2,                     // .
         Border.Break.Time1, Border.Break.Time2,         //  .
         Border.Recoil.Time1, Border.Recoil.Time2,       //   .
         Trend.Time1, Trend.Time2,                       // .
         Limit.Time1, Limit.Time2,                       // .
         Horizon.Time1, Horizon.Time2,                   // .
         Trace.Time1, Trace.Time2,                       // .
         Trace.Break.Time1, Trace.Break.Time2,           //  .
         Trace.Recoil.Time1, Trace.Recoil.Time2;         //   .
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   string SlaveName="Init";
   string ProgramTrace=SlaveName;
   string Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);
     }
   if( TraceIsAllowed ) Print(Message);
//----
   if( !IsStaticMode ) NewBar(SlaveName, ProgramTrace, "DeadLine");
   if( BarsBeforeActivate<0 ) BarsBeforeActivate=0;
   if( BarsBeforeConfirm<0 ) BarsBeforeConfirm=0;
   if( ExcludeFirstBar && ExcludeLastBar && BarsBeforeActivate<1 )
      BarsBeforeActivate=1;
   int Class, Type, Group;
   //      :
   while( Class<ClassTotal )
     {
      Type=0;
      while( Type<TypeTotal )
        {
         InitType(SlaveName, ProgramTrace, "", Class, Type);
         Type++;
        }
      Group=0;
      while( Group<GroupTotal )
        {
         DeleteGroup(SlaveName, ProgramTrace, "Init", Class, Group);
         LoadGroup(SlaveName, ProgramTrace, "ClearScreen", Class, Group);
         PaintGroup(SlaveName, ProgramTrace, "ClearScreen", Class, Group);
         Group++;
        }
      Class++;
     }
   //   :
   Class=0;
   while( Class<ClassTotal )
     {
      CreateClass(SlaveName, ProgramTrace, "", Class);
      Group=0;
      while( Group<GroupTotal )
        {
         LoadGroup(SlaveName, ProgramTrace, "Paint", Class, Group);
         PaintGroup(SlaveName, ProgramTrace, "", Class, Group);
         Group++;
        }
      Class++;
     }
   if( IsStaticMode )
     {
      IsStaticMode=false;
      start();                                           //  .
      IsStaticMode=true;
     }
   WindowRedraw();                                       //  .
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
bool NewBar(string MasterName, string ProgramTrace, string Parameter) 
  {
   string Message, SlaveName="NewBar";
   ProgramTrace=MasterName+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(false);
     }
   if( TraceIsAllowed ) Print(Message);
//----
   static datetime NewTime;                              //   
   bool NewBar=false;                                    //   
   if( NewTime!=Time[0] )
     {
      NewTime=Time[0];                                   //   
      NewBar=true;                                       //   
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return(NewBar);
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void InitType(string MasterName, string ProgramTrace, string Parameter, int Class, int Type)
  {
   string Message, SlaveName="InitType";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Type<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Type="+Type;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   Type.Back[Class,Type]=true;
   Type.Style[Class,Type]=STYLE_DOT;
   Type.Width[Class,Type]=1;
   if( Class==1 ) Type.Color[Class,Type]=ReducingLinesColor;
   else Type.Color[Class,Type]=RasingLinesColor;
   switch( Type )
        {
         case 0:
           {
            Type.Style[Class,Type]=STYLE_SOLID;
            if( Class==1 ) Type.Prefix[Class,Type]="TopTangent ";
            else Type.Prefix[Class,Type]="BottomTangent ";
            break;
           }
          case 1:
           {
            Type.Style[Class,Type]=STYLE_SOLID;
            Type.Width[Class,Type]=2;
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="SupportLevel ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="ResistanceLevel ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 2:
           {
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="SupportLevelBreak ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="ResistanceLevelBreak ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 3:
           {
            if( Class==1 ) Type.Prefix[Class,Type]="SupportLevelRecoil ";
            else Type.Prefix[Class,Type]="ResistanceLevelRecoil ";
            break;
           }
          case 4:
           {
            Type.Style[Class,Type]=STYLE_DASH;
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="SupportBorder ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="ResistanceBorder ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 5:
           {
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="SupportBorderBreak ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="ResistanceBorderBreak ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 6:
           {
            if( Class==1 ) Type.Prefix[Class,Type]="SupportBorderRecoil ";
            else Type.Prefix[Class,Type]="ResistanceBorderRecoil ";
            break;
           }
          case 7:
           {
            Type.Style[Class,Type]=STYLE_SOLID;
            Type.Width[Class,Type]=3;
            if( Class==1 ) Type.Prefix[Class,Type]="ReducingTrend ";
            else Type.Prefix[Class,Type]="RasingTrend ";
            break;
           }
          case 8:
           {
            Type.Style[Class,Type]=STYLE_SOLID;
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="BottomLimit ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="TopLimit ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 9:
           {
            Type.Style[Class,Type]=STYLE_DASH;
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="BottomHorizon ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="TopHorizon ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
            break;
           }
          case 10:
           {
            Type.Style[Class,Type]=STYLE_SOLID;
            if( Class==1 ) Type.Prefix[Class,Type]="ReducingTrace ";
            else Type.Prefix[Class,Type]="RasingTrace ";
            break;
           }
          case 11:
           {
            if( Class==1 ) Type.Prefix[Class,Type]="ReducingTraceBreak ";
            else Type.Prefix[Class,Type]="RasingTraceBreak ";
            break;
           }
          case 12:
           {
            if( Class==1 )
              {
               Type.Prefix[Class,Type]="ReducingTraceRecoil ";
               Type.Color[Class,Type]=RasingLinesColor;
              }
            else
              {
               Type.Prefix[Class,Type]="RasingTraceRecoil ";
               Type.Color[Class,Type]=ReducingLinesColor;
              }
           }
        }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Type="+Type;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void DeleteGroup(string MasterName, string ProgramTrace, string Parameter, int Class, int Group)
  {
   string Message, SlaveName="DeleteGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   int i;
   while( i<PropertyTotal )
     {
      Property[Class,Group,i]=0;
      i++;
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void ClearGroup(string MasterName, string ProgramTrace, string Parameter)
  {
   string Message, SlaveName="ClearGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   // :
   Tangent.Speed=0;
   Tangent.Time1=0;
   Tangent.Bar1=0;
   Tangent.Price1=0;
   Tangent.Time2=0;
   Tangent.Bar2=0;
   Tangent.Price2=0;
   Tangent.Finite=false;
   Tangent.Actual=false;
   //  :
   Level.Time1=0;
   Level.Bar1=0;
   Level.Price=0;
   Level.Time2=0;
   Level.Bar2=0;
   Level.Finite=false;
   //  :
   Border.Time1=0;
   Border.Bar1=0;
   Border.Price1=0;
   Border.Time2=0;
   Border.Bar2=0;
   Border.Price2=0;
   Border.Finite=false;
   ClearTrend(SlaveName, ProgramTrace, "");
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void ClearTrend(string MasterName, string ProgramTrace, string Parameter)
  {
   string Message, SlaveName="ClearTrend";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   // :
   Trend.Time1=0;
   Trend.Bar1=0;
   Trend.Price1=0;
   Trend.Time2=0;
   Trend.Bar2=0;
   Trend.Price2=0;
   Trend.Finite=false;
   //    :
   Level.Break.Time1=0;
   Level.Break.Bar1=0;
   Level.Break.Price=0;
   Level.Break.Bar2=0;
   Level.Break.Time2=0;
   Level.Break.Finite=false;
   //     :
   Level.Recoil.Time1=0;
   Level.Recoil.Bar1=0;
   Level.Recoil.Price=0;
   Level.Recoil.Time2=0;
   Level.Recoil.Bar2=0;
   Level.Recoil.Finite=false;
   //    :
   Border.Break.Time1=0;
   Border.Break.Bar1=0;
   Border.Break.Price1=0;
   Border.Break.Time2=0;
   Border.Break.Bar2=0;
   Border.Break.Price2=0;
   Border.Break.Finite=false;
   //     :
   Border.Recoil.Time1=0;
   Border.Recoil.Bar1=0;
   Border.Recoil.Price1=0;
   Border.Recoil.Time2=0;
   Border.Recoil.Bar2=0;
   Border.Recoil.Price2=0;
   Border.Recoil.Finite=false;
   //  :
   Limit.Time1=0;
   Limit.Bar1=0;
   Limit.Price=0;
   Limit.Time2=0;
   Limit.Bar2=0;
   Limit.Finite=false;
   //  :
   Horizon.Time1=0;
   Horizon.Bar1=0;
   Horizon.Price1=0;
   Horizon.Time2=0;
   Horizon.Bar2=0;
   Horizon.Price2=0;
   Horizon.Finite=false;
   ClearTrace(SlaveName, ProgramTrace, "");
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void ClearTrace(string MasterName, string ProgramTrace, string Parameter)
  {
   string Message, SlaveName="ClearTrace";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   // :
   Trace.Time1=0;
   Trace.Bar1=0;
   Trace.Price1=0;
   Trace.Time2=0;
   Trace.Bar2=0;
   Trace.Price2=0;
   Trace.Finite=false;
   //   :
   Trace.Break.Time1=0;
   Trace.Break.Bar1=0;
   Trace.Break.Price1=0;
   Trace.Break.Time2=0;
   Trace.Break.Bar2=0;
   Trace.Break.Price2=0;
   Trace.Break.Finite=false;
   //    :
   Trace.Recoil.Time1=0;
   Trace.Recoil.Bar1=0;
   Trace.Recoil.Price1=0;
   Trace.Recoil.Time2=0;
   Trace.Recoil.Bar2=0;
   Trace.Recoil.Price2=0;
   Trace.Recoil.Finite=false;
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void PaintGroup(string MasterName, string ProgramTrace, string Parameter, int Class, int Group)
  {
   string Message, SlaveName="PaintGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   bool Result, Finite;
   int Type;
   string Name, Text;
   double Price1, Price2;
   datetime Time1, Time2;
   while( Type<TypeTotal )
     {
      Name=Type.Prefix[Class,Type]+Group;
      if( ObjectFind(Name)>=0 )
        {
         Result=ObjectDelete(Name);
         if( !Result )
           {
            Message=Message+"   "+Name;
            Type++;
            continue;
           }
        }
      if( !Tangent.Actual || Tangent.Time1<=0 )
        {                                                //   .
         Type++;
         continue;
        }
      switch( Type )
        {
         case 0:
           {
            Time1=Tangent.Time1;
            Price1=Tangent.Price1;
            if( Trend.Time1<1 )
              {
               Time1=0;                                  //    .
               Time2=Tangent.Time2;
               Price2=Tangent.Price2;
               Finite=Tangent.Finite;
              }
            else
              {                                          //    .
               Time2=Trend.Time1;
               Price2=Trend.Price1;
               Finite=true;
              }
            Text="Tg"+Group;
            break;
           }
          case 1:
           {
            Time1=Level.Time1;
            if( Trend.Time1<1 || Trace.Time1>0 ) Time1=0;//     .
            Time2=Level.Time2;
            Price1=Level.Price;
            Price2=Price1;
            Finite=Level.Finite;
            Text="Lv"+Group;
            break;
           }
          case 2:
           {
            Time1=Level.Break.Time1;
            if( Trace.Time1>0 ) Time1=0;                 //     .
            Time2=Level.Break.Time2;
            Price1=Level.Break.Price;
            Price2=Price1;
            Finite=Level.Break.Finite;
            Text="LvBk"+Group;
            break;
           }
          case 3:
           {
            Time1=Level.Recoil.Time1;
            if( Trace.Time1>0 ) Time1=0;                 //     .
            Time2=Level.Recoil.Time2;
            Price1=Level.Recoil.Price;
            Price2=Price1;
            Finite=Level.Recoil.Finite;
            Text="LvRc"+Group;
            break;
           }
          case 4:
           {
            Time1=Border.Time1;
            if( Trend.Time1<1 ) Time1=0;                 //    .
            Time2=Border.Time2;
            Price1=Border.Price1;
            Price2=Border.Price2;
            Finite=Border.Finite;
            Text="Bd"+Group;
            break;
           }
          case 5:
           {
            Time1=Border.Break.Time1;
            if( Trace.Time1>0 ) Time1=0;                 //     .
            Time2=Border.Break.Time2;
            Price1=Border.Break.Price1;
            Price2=Border.Break.Price2;
            Finite=Border.Break.Finite;
            Text="BdBr"+Group;
            break;
           }
          case 6:
           {
            Time1=Border.Recoil.Time1;
            if( Trace.Time1>0 ) Time1=0;                 //     .
            Time2=Border.Recoil.Time2;
            Price1=Border.Recoil.Price1;
            Price2=Border.Recoil.Price2;
            Finite=Border.Recoil.Finite;
            Text="BdRc"+Group;
            break;
           }
          case 7:
           {
            Time1=Trend.Time1;
            Time2=Trend.Time2;
            Price1=Trend.Price1;
            Price2=Trend.Price2;
            Finite=Trend.Finite;
            Text="Td"+Group;
            break;
           }
          case 8:
           {
            Time1=Limit.Time1;
            if( Trace.Time1<1 ) Time1=0;                 //     .
            Time2=Limit.Time2;
            Price1=Limit.Price;
            Price2=Price1;
            Finite=Limit.Finite;
            Text="Lm"+Group;
            break;
           }
          case 9:
           {
            Time1=Horizon.Time1;
            if( Trace.Time1<1 ) Time1=0;                 //     .
            Time2=Horizon.Time2;
            Price1=Horizon.Price1;
            Price2=Horizon.Price2;
            Finite=Horizon.Finite;
            Text="Hz"+Group;
            break;
           }
          case 10:
           {
            Time1=Trace.Time1;
            Time2=Trace.Time2;
            Price1=Trace.Price1;
            Price2=Trace.Price2;
            Finite=Trace.Finite;
            Text="Tc"+Group;
            break;
           }
          case 11:
           {
            Time1=Trace.Break.Time1;
            Time2=Trace.Break.Time2;
            Price1=Trace.Break.Price1;
            Price2=Trace.Break.Price2;
            Finite=Trace.Break.Finite;
            Text="TcBr"+Group;
            break;
           }
          case 12:
           {
            Time1=Trace.Recoil.Time1;
            Time2=Trace.Recoil.Time2;
            Price1=Trace.Recoil.Price1;
            Price2=Trace.Recoil.Price2;
            Finite=Trace.Recoil.Finite;
            Text="TcRc"+Group;
           }
        }
      if( Time1>0 && Time2>Time1 && Price1>0 && Price2>0 )
        {
         Result=ObjectCreate(Name,OBJ_TREND,0,Time1,Price1,Time2,Price2);
         if( Result )
           {
            ObjectSetText(Name, Text);
            ObjectSet(Name, OBJPROP_RAY, !Finite);
            ObjectSet(Name, OBJPROP_COLOR, Type.Color[Class,Type]);
            ObjectSet(Name, OBJPROP_WIDTH, Type.Width[Class,Type]);
            ObjectSet(Name, OBJPROP_STYLE, Type.Style[Class,Type]);
            ObjectSet(Name, OBJPROP_BACK, Type.Back[Class,Type]);
            ObjectSet(Name, OBJPROP_TIMEFRAMES, OBJ_ALL_PERIODS);
           }
         else
            Message=Message+"   "+Name;
        }
      Type++;
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void CreateClass(string MasterName, string ProgramTrace, string Parameter, int Class)
  {
   string Message, SlaveName="CreateClass";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start Class="+Class;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   int Bar1, Bar2, BarM, Group;
   double Price1, Price2, PriceM, Speed, SpeedM;
   Bar1=Bars-1;
   if( Class==1 ) Price1=High[Bar1]; else Price1=Low[Bar1];
   while( Bar1>1 )
     {
      if( Class==1 ) SpeedM=-VeryBigValue; else SpeedM=VeryBigValue;
      Bar2=Bar1;
      while( Bar2>1 )
        {
         Bar2--;                                         //   .
         if( Class==1 ) Price2=High[Bar2]; else Price2=Low[Bar2];
         if( Bar1>Bar2 ) Speed=(Price2-Price1)/(Bar1-Bar2); else Speed=0;
         if( (Class==1 && Speed>=SpeedM) || (Class==0 && Speed<=SpeedM) )
           {                                             //  .
            BarM=Bar2;
            PriceM=Price2;
            SpeedM=Speed;
           }
        }
      CreateGroup(SlaveName, ProgramTrace, "", Class, Group, Bar1, Price1, BarM, PriceM);
      Group++;
      Bar1=BarM;
      Price1=PriceM;
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish"+" Class="+Class;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void CreateGroup(string MasterName, string ProgramTrace, string Parameter, int Class, int Group,
                 int Bar1, double Price1, int Bar2, double Price2)
  {
   string Message, SlaveName="CreateGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 || Bar1<=Bar2 || Price1<=0 || Price2<=0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Message=Message+" Bar1="+Bar1+" Time1="+TimeToStr(Time[Bar1])+" Price1="+DoubleToStr(Price1,Digits);
      Message=Message+" Bar2="+Bar2+" Time2="+TimeToStr(Time[Bar2])+" Price2="+DoubleToStr(Price2,Digits);
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   double Deviation;
   ClearGroup(SlaveName, ProgramTrace, "");
   Tangent.Bar1=Bar1;
   Tangent.Time1=Time[Bar1];
   Tangent.Price1=Price1;
   Tangent.Bar2=Bar2;
   Tangent.Time2=Time[Bar2];
   Tangent.Price2=Price2;
   if( (Bar1-Bar2<=BarsBeforeActivate)
    || (Class==0 && Price1>=Price2)
    || (Class==1 && Price1<=Price2) )
     {                                                   //  .
      SaveGroup(SlaveName, ProgramTrace, "NotActual", Class, Group);
      Message=Message+" Bar1="+Bar1+"("+TimeToStr(Time[Bar1])+")"+DoubleToStr(Price1,Digits);
      Message=Message+" Bar2="+Bar2+"("+TimeToStr(Time[Bar2])+")"+DoubleToStr(Price2,Digits);
      Message=Message+" Not Actual Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   Tangent.Actual=true;
   Tangent.Speed=(Price2-Price1)/(Point*(Bar1-Bar2));
   BreakPoints(SlaveName, ProgramTrace, "Tangent", Bar1, Bar2, Price1, Tangent.Speed);
   if( Class==0 )
     {
      Level.Bar1=BarPriceMax;
      Level.Price=PriceMax;
      Border.Bar1=BarDevMax;
      Deviation=DevMax;
     }
   else
     {
      Level.Bar1=BarPriceMin;
      Level.Price=PriceMin;
      Border.Bar1=BarDevMin;
      Deviation=DevMin;
     }
   Level.Time1=Time[Level.Bar1];
   Border.Time1=Time[Border.Bar1];
   Border.Price1=Tangent.Price1+Tangent.Speed*Point*(Tangent.Bar1-Border.Bar1)+Deviation;
   BreakPoints(SlaveName, ProgramTrace, "Lv"+Class+","+Group, Level.Bar1, BarsBeforeConfirm, Level.Price, 0);
   if( FirstBreakBar>BarsBeforeConfirm )
     {                                                   //   .
      //  :
      Trend.Bar1=FirstBreakBar;
      Trend.Time1=Time[FirstBreakBar];
      Trend.Price1=Tangent.Price1+Tangent.Speed*Point*(Tangent.Bar1-Trend.Bar1);
      CreateTrend(SlaveName, ProgramTrace, "", Class, Group);
     }
   SaveGroup(SlaveName, ProgramTrace, "", Class, Group);
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" Bar1="+Bar1+"("+TimeToStr(Time[Bar1])+")"+DoubleToStr(Price1,Digits);
      Message=Message+" Bar2="+Bar2+"("+TimeToStr(Time[Bar2])+")"+DoubleToStr(Price2,Digits);
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|       
//+------------------------------------------------------------------+
void BreakPoints(string MasterName, string ProgramTrace, string Parameter,
                 int FirstBar, int LastBar, double Price, double Speed)
  {
   string Message, SlaveName="BreakPoints";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || FirstBar<=LastBar || Price<=0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" FirstBar="+FirstBar+"("+TimeToStr(Time[FirstBar]);
      Message=Message+") LastBar="+LastBar+"("+TimeToStr(Time[LastBar]);
      Message=Message+") Price="+DoubleToStr(Price,Digits)+" Speed="+DoubleToStr(Speed,1);
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   double DMax, DMin, PMax, PMin, PDMax, PDMin;
   DevMin=VeryBigValue; DevMax=-VeryBigValue;
   PriceMin=VeryBigValue; PriceMax=-VeryBigValue;
   FirstBreakBar=-1; LastBreakBar=-1;
   int i=FirstBar;
   if( ExcludeFirstBar ) {i--; Price+=Point*Speed;}
   int j=LastBar;
   if( ExcludeLastBar ) j++;
   BarDevMax=i; BarDevMin=i;
   BarPriceMax=i; BarPriceMin=i;
   while( i>=j )
     {
      PMax=High[i]; DMax=PMax-Price;
      PMin=Low[i]; DMin=PMin-Price;
      if( PMax>PriceMax ) {PriceMax=PMax; BarPriceMax=i;}
      if( PMin<PriceMin ) {PriceMin=PMin; BarPriceMin=i;}
      if( DMax>DevMax ) {DevMax=DMax; BarDevMax=i;}
      if( DMin<DevMin ) {DevMin=DMin; BarDevMin=i;}
      if( ( DMin<0 && DMax>0 ) || ( PDMax<0 && DMin>0 ) || ( PDMin>0 && DMax<0 ) )
        {
         if( FirstBreakBar<0 ) FirstBreakBar=i;          //  .
         LastBreakBar=i;                                 //  .
        }
      PDMax=DMax; PDMin=DMin;
      Price+=Point*Speed;                                //   
      i--;                                               //     .
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" FirstBar="+FirstBar+"("+TimeToStr(Time[FirstBar]);
      Message=Message+") LastBar="+LastBar+"("+TimeToStr(Time[LastBar]);
      Message=Message+") Price="+DoubleToStr(Price,Digits)+" Speed="+DoubleToStr(Speed,1);
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void CreateTrend(string MasterName, string ProgramTrace, string Parameter, int Class, int Group)
  {
   string Message, SlaveName="CreateTrend";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   double Deviation, Price;
   //   :
   Level.Break.Bar1=FirstBreakBar;
   Level.Recoil.Bar1=FirstBreakBar;
   Level.Break.Time1=Time[FirstBreakBar];
   Level.Recoil.Time1=Time[FirstBreakBar];
   //     :
   Level.Bar2=LastBreakBar;
   Level.Break.Bar2=LastBreakBar;
   Level.Recoil.Bar2=LastBreakBar;
   Level.Time2=Time[LastBreakBar];
   Level.Break.Time2=Time[LastBreakBar];
   Level.Recoil.Time2=Time[LastBreakBar];
   Level.Finite=true;
   Level.Break.Finite=true;
   Level.Recoil.Finite=true;
   //   .
   BreakPoints(SlaveName, ProgramTrace, "LvCh"+Class+","+Group, FirstBreakBar, LastBreakBar, Level.Price, 0);
   if( Class==0 )
     {
      Level.Break.Price=Level.Price+DevMax;
      Level.Recoil.Price=Level.Price+DevMin;
     }
   else
     {
      Level.Break.Price=Level.Price+DevMin;
      Level.Recoil.Price=Level.Price+DevMax;
     }
   //  :
   BreakPoints(SlaveName, ProgramTrace, "Bd"+Class+","+Group, Border.Bar1, 1, Border.Price1, Tangent.Speed);
   if( FirstBreakBar>0 )
     {                                                //   .
      //  :
      Border.Break.Bar1=FirstBreakBar;
      Border.Recoil.Bar1=FirstBreakBar;
      Border.Break.Time1=Time[FirstBreakBar];
      Border.Recoil.Time1=Time[FirstBreakBar];
      //  :
      Border.Break.Bar2=LastBreakBar;
      Border.Recoil.Bar2=LastBreakBar;
      Border.Break.Time2=Time[LastBreakBar];
      Border.Recoil.Time2=Time[LastBreakBar];
      Border.Break.Finite=true;
      Border.Recoil.Finite=true;
      //  .
      Price=Border.Price1+Tangent.Speed*Point*(Border.Bar1-FirstBreakBar);
      BreakPoints(SlaveName, ProgramTrace, "BdCh"+Class+","+Group, FirstBreakBar, LastBreakBar, Price, Tangent.Speed);
      if( Class==0 )
        {
         Border.Break.Price1=Price+DevMax;
         Border.Recoil.Price1=Price+DevMin;
        }
      else
        {
         Border.Break.Price1=Price+DevMin;
         Border.Recoil.Price1=Price+DevMax;
        }
      Border.Break.Price2=Border.Break.Price1+Tangent.Speed*Point*(Border.Break.Bar1-Border.Break.Bar2);
      Border.Recoil.Price2=Border.Recoil.Price1+Border.Break.Price2-Border.Break.Price1;
     }
   //    :
   BreakPoints(SlaveName, ProgramTrace, "Lm&Hz"+Class+","+Group, Tangent.Bar2, 1, Tangent.Price2, Tangent.Speed);
   if( Class==0 )
     {
      Limit.Bar1=BarPriceMax;
      Limit.Price=PriceMax;
      Horizon.Bar1=BarDevMax;
      Deviation=DevMax;
     }
   else
     {
      Limit.Bar1=BarPriceMin;
      Limit.Price=PriceMin;
      Horizon.Bar1=BarDevMin;
      Deviation=DevMin;
     }
   Limit.Time1=Time[Limit.Bar1];
   Horizon.Time1=Time[Horizon.Bar1];
   Horizon.Price1=Tangent.Price1+Tangent.Speed*Point*(Tangent.Bar1-Horizon.Bar1)+Deviation;
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void SaveGroup(string MasterName, string ProgramTrace, string Parameter, int Class, int Group)
  {
   string Message, SlaveName="SaveGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   // :
   Property[Class,Group,0]=Tangent.Time1;                //  .
   Property[Class,Group,1]=Tangent.Price1;
   Property[Class,Group,2]=Level.Time1;                  //   .
   Property[Class,Group,3]=Level.Price;
   Property[Class,Group,4]=Border.Time1;                 //   .
   Property[Class,Group,5]=Border.Price1;
   Property[Class,Group,6]=Tangent.Time2;                //  .
   Property[Class,Group,7]=Tangent.Price2;
   // :
   Property[Class,Group,8]=Trend.Time1;                  //  .
   Property[Class,Group,9]=Level.Break.Price;            //   
   Property[Class,Group,10]=Level.Recoil.Price;          //      .
   Property[Class,Group,11]=Level.Break.Time2;           //    .
   Property[Class,Group,12]=Border.Break.Price1;         //    
   Property[Class,Group,13]=Border.Recoil.Price1;        //      .
   Property[Class,Group,14]=Border.Break.Time1;          //    
   Property[Class,Group,15]=Border.Break.Time2;          //      .
   Property[Class,Group,16]=Limit.Time1;                 //   .
   Property[Class,Group,17]=Limit.Price;
   Property[Class,Group,18]=Horizon.Time1;               //   .
   Property[Class,Group,19]=Horizon.Price1;
   Property[Class,Group,20]=Trend.Time2;                 //   .
   // :
   Property[Class,Group,21]=Trace.Time1;                 //   .
   Property[Class,Group,22]=Trace.Break.Price1;          //   
   Property[Class,Group,23]=Trace.Recoil.Price1;         //      .
   Property[Class,Group,24]=Trace.Time2;                 //  .
   //  :
   Property[Class,Group,25]=Tangent.Finite;
   Property[Class,Group,26]=Level.Finite;
   Property[Class,Group,27]=Level.Break.Finite;
   Property[Class,Group,28]=Level.Recoil.Finite;
   Property[Class,Group,29]=Border.Finite;
   Property[Class,Group,30]=Border.Break.Finite;
   Property[Class,Group,31]=Border.Recoil.Finite;
   Property[Class,Group,32]=Trend.Finite;
   Property[Class,Group,33]=Limit.Finite;
   Property[Class,Group,34]=Horizon.Finite;
   Property[Class,Group,35]=Trace.Finite;
   Property[Class,Group,36]=Trace.Break.Finite;
   Property[Class,Group,37]=Trace.Recoil.Finite;
   Property[Class,Group,38]=Tangent.Actual;              //  .
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
void LoadGroup(string MasterName, string ProgramTrace, string Parameter, int Class, int Group)
  {
   string Message, SlaveName="LoadGroup";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   ClearGroup(SlaveName, ProgramTrace, "");
   // :
   Tangent.Time1=Property[Class,Group,0];                //  .
   Tangent.Price1=Property[Class,Group,1];               //  .
   Tangent.Time2=Property[Class,Group,6];                //  .
   Tangent.Price2=Property[Class,Group,7];               //  .
   if( Tangent.Time1<=0 || Tangent.Time2<=Tangent.Time1
    || Tangent.Price1<=0 || Tangent.Price2<=0 )
     {
      ClearGroup(SlaveName, ProgramTrace, "Empty");
      SaveGroup(SlaveName, ProgramTrace, "Empty", Class, Group);
      LastErrorCode=GetLastError();
      if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
      if( Message!=ProgramTrace )
        {
         Message=Message+" EMPTY Class="+Class+" Group="+Group;
         Print(Message);
        }
      return;
     }
   Tangent.Finite=Property[Class,Group,25];              // .
   Tangent.Actual=Property[Class,Group,38];              // .
   Tangent.Bar1=iBarShift(NULL,0,Tangent.Time1);
   Tangent.Bar2=iBarShift(NULL,0,Tangent.Time2);
   if( Tangent.Bar1>Tangent.Bar2 )
      Tangent.Speed=(Tangent.Price2-Tangent.Price1)/(Point*(Tangent.Bar1-Tangent.Bar2));
   //  :
   Border.Time1=Property[Class,Group,4];                 // .
   if( Border.Time1<=0 )
     {
      LastErrorCode=GetLastError();
      if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
      if( Message!=ProgramTrace )
        {
         Message=Message+" NOT ACTUAL Class="+Class+" Group="+Group;
         Print(Message);
        }
      return;
     }
   if( Border.Time1<=Tangent.Time1 )
     {
      Border.Time1=Tangent.Time1;
      Border.Bar1=Tangent.Bar1;
     }
   else
      if ( Border.Time1>=Tangent.Time2 )
        {
         Border.Time1=Tangent.Time2;
         Border.Bar1=Tangent.Bar2;
        }
      else Border.Bar1=iBarShift(NULL,0,Border.Time1);
   Border.Bar2=Border.Bar1-1;                            //  .
   Border.Time2=Time[Border.Bar2];
   Border.Price1=Property[Class,Group,5];                // .
   if( Border.Price1<=0 )
     {
      Message=Message+" Border.Price1=0";
      Border.Price1=0;
     }
   else Border.Price2=Border.Price1+Tangent.Speed*Point;
   Border.Finite=Property[Class,Group,29];               // .
   //  :
   Level.Time1=Property[Class,Group,2];                  //   .
   if( Level.Time1<=Border.Time1 )
     {
      Level.Time1=Border.Time1;
      Level.Bar1=Border.Bar1;
     }
   else
      if ( Level.Time1>=Tangent.Time2 )
        {
         Level.Time1=Tangent.Time2;
         Level.Bar1=Tangent.Bar2;
        }
      else Level.Bar1=iBarShift(NULL,0,Level.Time1);
   Level.Bar2=Level.Bar1-1;
   Level.Time2=Time[Level.Bar2];
   Level.Price=Property[Class,Group,3];                  // .
   if( Level.Price<=0 )
     {
      Message=Message+" Level.Price=0";
      Level.Price=0;
     }
   Level.Finite=Property[Class,Group,26];                // .
   // :
   Trend.Time1=Property[Class,Group,8];                  //  .
   if( Trend.Time1<=0 )
     {
      ClearTrend(SlaveName, ProgramTrace, "Tangent");
      SaveGroup(SlaveName, ProgramTrace, "Tangent", Class, Group);
      LastErrorCode=GetLastError();
      if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
      if( Message!=ProgramTrace )
        {
         Message=Message+" TANGENT Class="+Class+" Group="+Group;
         Print(Message);
        }
      return;
     }
   if( Trend.Time1<=Tangent.Time2 )
     {
      Trend.Time1=Tangent.Time2;
      Trend.Bar1=Tangent.Bar2;
     }
   else Trend.Bar1=iBarShift(NULL,0,Trend.Time1);
   Trend.Time2=Property[Class,Group,20];                 //  .
   if( Trend.Time2>Trend.Time1 )
      Trend.Bar2=iBarShift(NULL,0,Trend.Time2);
   else
      Trend.Bar2=Trend.Bar1;
   if( Trend.Bar2>=Trend.Bar1 )
     {
      Trend.Bar2=Trend.Bar1-1;
      if( Trend.Bar2>=0 ) Trend.Time2=Time[Trend.Bar2];
      else Message=Message+" Trend.Bar2="+Trend.Bar2;
     }
   Trend.Price1=Tangent.Price2+Tangent.Speed*Point*(Tangent.Bar2-Trend.Bar1);
   Trend.Price2=Trend.Price1+Tangent.Speed*Point*(Trend.Bar1-Trend.Bar2);
   Trend.Finite=Property[Class,Group,32];                // .
   //    :
   Level.Break.Time1=Trend.Time1;                        //  .
   Level.Break.Bar1=Trend.Bar1;
   Level.Recoil.Time1=Trend.Time1;
   Level.Recoil.Bar1=Trend.Bar1;
   Level.Break.Time2=Property[Class,Group,11];           //  .
   if( Level.Break.Time2>Level.Break.Time1 )
      Level.Break.Bar2=iBarShift(NULL,0,Level.Break.Time2);
   else
      Level.Break.Bar2=Level.Break.Bar1;
   if( Level.Break.Bar2>=Level.Break.Bar1 )
     {
      Level.Break.Bar2=Level.Break.Bar1-1;
      if( Level.Break.Bar2>=0 ) Level.Break.Time2=Time[Level.Break.Bar2];
      else Message=Message+" Level.Break.Bar2="+Level.Break.Bar2;
     }
   Level.Recoil.Time2=Level.Break.Time2;
   Level.Recoil.Bar2=Level.Break.Bar2;
   Level.Break.Price=Property[Class,Group,9];            //  .
   if( Level.Break.Price<=0 )
     {
      Message=Message+" Level.Break.Price=0";
      Level.Break.Price=0;
     }
   Level.Recoil.Price=Property[Class,Group,10];          //  .
   if( Level.Recoil.Price<=0 )
     {
      Message=Message+" Level.Recoil.Price=0";
      Level.Recoil.Price=0;
     }
   Level.Break.Finite=Property[Class,Group,27];          //   .
   Level.Recoil.Finite=Property[Class,Group,28];         //   .
   Level.Time2=Level.Break.Time2;
   Level.Bar2=Level.Break.Bar2;
   //    :
   Border.Break.Time1=Property[Class,Group,14];          //  .
   if( Border.Break.Time1>Level.Break.Time1 )
      Border.Break.Bar1=iBarShift(NULL,0,Border.Break.Time1);
   else
     {
      Border.Break.Time1=Level.Break.Time1;
      Border.Break.Bar1=Level.Break.Bar1;
     }
   Border.Recoil.Time1=Border.Break.Time1;
   Border.Recoil.Bar1=Border.Break.Bar1;
   Border.Break.Time2=Property[Class,Group,15];          //  .
   if( Border.Break.Time2>Border.Break.Time1 )
      Border.Break.Bar2=iBarShift(NULL,0,Border.Break.Time2);
   else
      Border.Break.Bar2=Border.Break.Bar1;
   if( Border.Break.Bar2>=Border.Break.Bar1 )
     {
      Border.Break.Bar2=Border.Break.Bar1-1;
      if( Border.Break.Bar2>=0 ) Border.Break.Time2=Time[Border.Break.Bar2];
      else Message=Message+" Border.Break.Bar2="+Border.Break.Bar2;
     }
   Border.Recoil.Time2=Border.Break.Time2;
   Border.Recoil.Bar2=Border.Break.Bar2;
   Border.Break.Price1=Property[Class,Group,12];
   if( Border.Break.Price1<=0 )
     {
      Message=Message+" Border.Break.Price1=0";
      Border.Break.Price1=0;
     }
   else Border.Break.Price2=Border.Break.Price1+
                       Tangent.Speed*Point*(Border.Break.Bar1-Border.Break.Bar2);
   Border.Recoil.Price1=Property[Class,Group,13];
   if( Border.Recoil.Price1<=0 )
     {
      Message=Message+" Border.Recoil.Price1=0";
      Border.Recoil.Price1=0;
     }
   else Border.Recoil.Price2=Border.Recoil.Price1+Border.Break.Price2-Border.Break.Price1;
   Border.Break.Finite=Property[Class,Group,30];         //   .
   Border.Recoil.Finite=Property[Class,Group,31];        //   .
   Border.Time2=Border.Break.Time2;
   Border.Bar2=Border.Break.Bar2;
   Border.Price2=Border.Price1+Tangent.Speed*Point*(Border.Bar1-Border.Bar2);
   //  :
   Horizon.Time1=Property[Class,Group,18];               // .
   if( Horizon.Time1<1 ) Message=Message+" Horizon.Time1=0...Trend.Time1";
   if( Horizon.Time1<=Trend.Time1 )
     {
      Horizon.Time1=Trend.Time1;
      Horizon.Bar1=Trend.Bar1;
     }
   else Horizon.Bar1=iBarShift(NULL,0,Horizon.Time1);
   Horizon.Price1=Property[Class,Group,19];
   if( Horizon.Price1<=0 )
     {
      Message=Message+" Horizon.Price1=0";
      Horizon.Price1=0;
     }
   Horizon.Bar2=Horizon.Bar1-1;                          //   .
   Horizon.Time2=Time[Horizon.Bar2];
   Horizon.Price2=Horizon.Price1+Tangent.Speed*Point;
   Horizon.Finite=Property[Class,Group,34];              // .
   //  :
   Limit.Time1=Property[Class,Group,16];                 //   .
   if( Limit.Time1<1 ) Message=Message+" Limit.Time1=0...Horizon.Time1";
   if( Limit.Time1<=Horizon.Time1 )
     {
      Limit.Time1=Horizon.Time1;
      Limit.Bar1=Horizon.Bar1;
     }
   else Limit.Bar1=iBarShift(NULL,0,Limit.Time1);
   Limit.Bar2=Limit.Bar1-1;                              //   .
   Limit.Time2=Time[Limit.Bar2];
   Limit.Price=Property[Class,Group,17];                 // .
   if( Limit.Price<=0 )
     {
      Message=Message+" Limit.Price=0";
      Limit.Price=0;
     }
   Limit.Finite=Property[Class,Group,33];                // .
   // :
   Trace.Time1=Property[Class,Group,21];                 //  .
   if( Trace.Time1!=Trend.Time2 )
     {
      LastErrorCode=GetLastError();
      if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
      if( Trace.Time1>0 )
        {
         Message=Message+" Trace.Time1="+DoubleToStr(Trace.Time1,Digits);
         Message=Message+" Trend.Time2="+DoubleToStr(Trend.Time2,Digits);
         Message=Message+" STOP";
        }
      else
        {
         ClearTrace(SlaveName, ProgramTrace, "Trend");
         SaveGroup(SlaveName, ProgramTrace, "Trend", Class, Group);
        }
      if( Message!=ProgramTrace )
        {
         Message=Message+" TREND Class="+Class+" Group="+Group;
         Print(Message);
        }
      return;
     }
   Trace.Bar1=Trend.Bar2;
   Trace.Price1=Trend.Price2;
   Trace.Time2=Property[Class,Group,24];                 //  .
   if( Trace.Time2>Trace.Time1 )
      Trace.Bar2=iBarShift(NULL,0,Trace.Time2);
   else
      Trace.Bar2=Trace.Bar1;
   if( Trace.Bar2>=Trace.Bar1 )
     {
      Trace.Bar2=Trace.Bar1-1;
      if( Trace.Bar2>=0 ) Trace.Time2=Time[Trace.Bar2];
      else Message=Message+" Trace.Bar2="+Trace.Bar2;
     }
   Trace.Price2=Trace.Price1+Tangent.Speed*Point*(Trace.Bar1-Trace.Bar2);
   Trace.Finite=Property[Class,Group,35];                // .
   //  :
   Border.Time2=Trace.Time2;
   Limit.Time2=Trace.Time2;
   Horizon.Time2=Trace.Time2;
   Border.Bar2=Trace.Bar2;
   Limit.Bar2=Trace.Bar2;
   Horizon.Bar2=Trace.Bar2;
   Border.Price2=Border.Price1+Tangent.Speed*Point*(Border.Bar1-Border.Bar2);
   Horizon.Price2=Horizon.Price1+Tangent.Speed*Point*(Horizon.Bar1-Horizon.Bar2);
   Border.Finite=Trace.Finite;
   Limit.Finite=Trace.Finite;
   Horizon.Finite=Trace.Finite;
   //   :
   Trace.Break.Time1=Trace.Time1;                        //   .
   Trace.Break.Bar1=Trace.Bar1;
   Trace.Recoil.Time1=Trace.Time1;                       //   .
   Trace.Recoil.Bar1=Trace.Bar1;
   Trace.Break.Time2=Trace.Time2;                        //   .
   Trace.Break.Bar2=Trace.Bar2;
   Trace.Recoil.Time2=Trace.Time2;                       //   .
   Trace.Recoil.Bar2=Trace.Bar2;
   Trace.Break.Price1=Property[Class,Group,22];          //   .
   if( Trace.Break.Price1<=0 )
     {
      Message=Message+" Trace.Break.Price1=0";
      Trace.Break.Price1=0;
     }
   else Trace.Break.Price2=Trace.Break.Price1+Trace.Price2-Trace.Price1;
   Trace.Recoil.Price1=Property[Class,Group,23];         //   .
   if( Trace.Recoil.Price1<=0 )
     {
      Message=Message+" Trace.Recoil.Price1=0";
      Trace.Recoil.Price1=0;
     }
   else Trace.Recoil.Price2=Trace.Recoil.Price1+Trace.Price2-Trace.Price1;
   Trace.Break.Finite=Property[Class,Group,36];          //   .
   Trace.Recoil.Finite=Property[Class,Group,37];         //   
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class+" Group="+Group;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   string SlaveName="Start";
   string ProgramTrace=SlaveName;
   string Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);
     }
   if( TraceIsAllowed ) Print(Message);
//----
   if( IsStaticMode ) return(0);                         //   .
   int Class, Group;
   if( NewBar(SlaveName, ProgramTrace, "") )
     {
      while( Class<ClassTotal )
        {                                                //  .
         Group=0;
         ClearGroup(SlaveName, ProgramTrace, "ClearScreen");
         while( Group<GroupTotal )
           {
            PaintGroup(SlaveName, ProgramTrace, "ClearScreen", Class, Group);
            Group++;
           }
         ModifyClass(SlaveName, ProgramTrace, "", Class);
         Class++;
        }
      WindowRedraw();                                    //  .
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void ModifyClass(string MasterName, string ProgramTrace, string Parameter, int Class)
  {
   string Message, SlaveName="ModifyClass";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class;
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   int Group, G, Bar0;
   double Price, Price1, Price0;                         // : , , .
   bool First=true;                                      //  ?
   if( Class==0 ) Price1=Low[1]; else Price1=High[1];
   while( Group<GroupTotal )
     {                                                   //  .
      LoadGroup(SlaveName, ProgramTrace, "Renew", Class, Group);
      if( Tangent.Time1<1 )
        {                                                //   .
         DeleteGroup(SlaveName, ProgramTrace, "Empty", Class, Group);
         Group++;
         continue;
        }
      Price=Tangent.Price1+Tangent.Speed*Point*(Tangent.Bar1-1);
      if( Trace.Time1>0 )                                //  .
         CreateTrace(SlaveName, ProgramTrace, "Modify", Class, Group,
                     Trace.Bar1, Trace.Price1, 1, Price);
      else
        {
         if( ( Class==0 && Price1<Price ) || ( Class==1 && Price1>Price ) )
           {                                             // .
            if( First )
              {                                          //   .
               Bar0=Tangent.Bar1;
               Price0=Tangent.Price1;
               First=false;
              }
            if(Trend.Time1>0)
              {                                          //  .
               Trend.Bar2=1;
               Trend.Time2=Time[1];
               Trend.Price2=Price;
               Trend.Finite=true;
               Trace.Bar1=Trend.Bar2;
               Trace.Time1=Trend.Time2;
               Trace.Price1=Trend.Price2;
               SaveGroup(SlaveName, ProgramTrace, "TrendBreak", Class, Group);
              }
            else                                         //  .
               DeleteGroup(SlaveName, ProgramTrace, "TangentBreak", Class, Group);
           }
         else
           {                                             //  .
            CreateGroup(SlaveName, ProgramTrace, "Modify", Class, Group,
                        Tangent.Bar1, Tangent.Price1, Tangent.Bar2, Tangent.Price2);
            if( First )
              {                                          //   .
               Bar0=Tangent.Bar2;
               Price0=Tangent.Price2;
              }
           }
        }
      Group++;
     }
   Group=0;
   while( Group<GroupTotal )
     {                                                   //  .
      LoadGroup(SlaveName, ProgramTrace, "FindEmpty", Class, Group);
      if( Tangent.Time1<1 )
        {                                                //   .
         G=Group+1;
         while( G<GroupTotal )
           {                                             //    .
            LoadGroup(SlaveName, ProgramTrace, "FindActual", Class, G);
            if( Tangent.Time1>0 )
              {                                          //    .
               SaveGroup(SlaveName, ProgramTrace, "SaveActual", Class, Group);
               DeleteGroup(SlaveName, ProgramTrace, "ClearNotActual", Class, G);
               break;
              }
            G++;
           }
         if( G>=GroupTotal ) break;
        }
      Group++;
     }
   Group=0;
   while( Group<GroupTotal )
     {
      LoadGroup(SlaveName, ProgramTrace, "Painting", Class, Group);
      if( Tangent.Time1<1 )
        {                                                //  .
         CreateGroup(SlaveName, ProgramTrace, "New", Class, Group, Bar0, Price0, 1, Price1);
         PaintGroup(SlaveName, ProgramTrace, "New", Class, Group);
         break;
        }
      PaintGroup(SlaveName, ProgramTrace, "", Class, Group);
      Group++;
     }
   if( Group>=GroupTotal ) Message=Message+" Old Empty Group="+Group;
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Message=Message+" Class="+Class;
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void CreateTrace(string MasterName, string ProgramTrace, string Parameter, int Class, int Group,
                 int Bar1, double Price1, int Bar2, double Price2)
  {
   string Message, SlaveName="CreateTrace";
   ProgramTrace=ProgramTrace+"=>"+SlaveName;
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 || Class<0 || Group<0 || Bar1<=Bar2 || Price1<=0 || Price2<=0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+" Class="+Class+" Group="+Group;
      Message=Message+" Bar1="+Bar1+" Time1="+TimeToStr(Time[Bar1])+" Price1="+DoubleToStr(Price1,Digits);
      Message=Message+" Bar2="+Bar2+" Time2="+TimeToStr(Time[Bar2])+" Price2="+DoubleToStr(Price2,Digits);
      Print(Message); return;
     }
   if( TraceIsAllowed ) Print(Message);
//----
   Border.Finite=true;
   Limit.Finite=true;
   Horizon.Finite=true;
   Trace.Finite=true;
   
   SaveGroup(SlaveName, ProgramTrace, "", Class, Group);
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish"+" Class="+Class+" Group="+Group;
      Message=Message+" Bar1="+Bar1+" Time1="+TimeToStr(Time[Bar1])+" Price1="+DoubleToStr(Price1,Digits);
      Message=Message+" Bar2="+Bar2+" Time2="+TimeToStr(Time[Bar2])+" Price2="+DoubleToStr(Price2,Digits);
      Print(Message);
     }
   return;
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   string SlaveName="DeInit";
   string ProgramTrace=SlaveName;
   string Message=ProgramTrace;
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);
     }
   if( TraceIsAllowed ) Print(Message);
//----
   int Class, Group;
   if( ClearAtFinish )
     {
      ClearGroup(SlaveName, ProgramTrace, "ClearScreen");
      while( Class<ClassTotal )
        {
         Group=0;
         while( Group<GroupTotal )
           {
            PaintGroup(SlaveName, ProgramTrace, "ClearScreen", Class, Group);
            Group++;
           }
         Class++;
        }
      WindowRedraw();                                    //  .
     }
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {
      Message=Message+" at Finish";
      Print(Message);
     }
   return(0);
  }
/*
extern bool TraceIsAllowed;                              //  ?
//+------------------------------------------------------------------+
//| XXX
//+------------------------------------------------------------------+
void XXX(string MasterName, string ProgramTrace, string Parameter)
  {
   string SlaveName="XXX";                               //  .
   ProgramTrace=ProgramTrace+"=>"+SlaveName;             //    .
   if( Parameter!="" ) ProgramTrace=ProgramTrace+"("+Parameter+")";
   string Message=ProgramTrace;                          //  .
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {                                                   //    .
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Message=Message+"";                                //  .
      Print(Message); return;                            //   .
     }
   if( TraceIsAllowed ) Print(Message);                  //    .
//----
   
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {                                                   //   .
      Message=Message+" at Finish";                      //  .
      Message=Message+"";                                //  .
      Print(Message);                                    //   .
     }
   return;
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   string SlaveName="Init";                              //  .
   string ProgramTrace=SlaveName;                        //    .
   string Message=ProgramTrace;                          //  .
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {                                                   //    .
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);                         //   .
     }
   if( TraceIsAllowed ) Print(Message);                  //    .
//----
   
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {                                                   //   .
      Message=Message+" at Finish";                      //  .
      Print(Message);                                    //   .
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   string SlaveName="Start";                             //  .
   string ProgramTrace=SlaveName;                        //    .
   string Message=ProgramTrace;                          //  .
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {                                                   //    .
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);                         //   .
     }
   if( TraceIsAllowed ) Print(Message);                  //    .
//----
   
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {                                                   //   .
      Message=Message+" at Finish";                      //  .
      Print(Message);                                    //   .
     }
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   string SlaveName="DeInit";                            //  .
   string ProgramTrace=SlaveName;                        //    .
   string Message=ProgramTrace;                          //  .
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 )
     {                                                   //    .
      Message=Message+" ERROR "+LastErrorCode+" at Start";
      Print(Message); return(0);                         //   .
     }
   if( TraceIsAllowed ) Print(Message);                  //    .
//----
   
//----
   LastErrorCode=GetLastError();
   if( LastErrorCode>0 ) Message=Message+" ERROR "+LastErrorCode;
   if( Message!=ProgramTrace )
     {                                                   //   .
      Message=Message+" at Finish";                      //  .
      Print(Message);                                    //   .
     }
   return(0);
  }
*/
//+------------------------------------------------------------------+